summaryrefslogtreecommitdiffstats
path: root/builder/modules.d/slx-network/scripts
diff options
context:
space:
mode:
authorJonathan Bauer2019-08-01 14:55:11 +0200
committerJonathan Bauer2019-08-01 14:55:11 +0200
commite35bce0d1bdce2d53573c75f496545d601a1ac8c (patch)
tree3cbad21b2eaa29c92eeddf9955bdb1e9edf962d8 /builder/modules.d/slx-network/scripts
parent[slx-network] setup network on udev settles (diff)
downloadsystemd-init-e35bce0d1bdce2d53573c75f496545d601a1ac8c.tar.gz
systemd-init-e35bce0d1bdce2d53573c75f496545d601a1ac8c.tar.xz
systemd-init-e35bce0d1bdce2d53573c75f496545d601a1ac8c.zip
[slx-network] do not bridge additional nic
+ bug fixes
Diffstat (limited to 'builder/modules.d/slx-network/scripts')
-rwxr-xr-xbuilder/modules.d/slx-network/scripts/setup-network88
-rwxr-xr-xbuilder/modules.d/slx-network/scripts/udhcpc-trigger115
2 files changed, 203 insertions, 0 deletions
diff --git a/builder/modules.d/slx-network/scripts/setup-network b/builder/modules.d/slx-network/scripts/setup-network
new file mode 100755
index 00000000..1f9eaddf
--- /dev/null
+++ b/builder/modules.d/slx-network/scripts/setup-network
@@ -0,0 +1,88 @@
+#!/bin/bash
+
+type emergency_shell >/dev/null 2>&1 || . /lib/dracut-lib.sh
+
+. /run/openslx/network.conf
+
+_logfile="/run/openslx/network.log"
+
+# for the boot interface?
+if [ ! -e "/sys/class/net/${SLX_PXE_NETIF}/device" ]; then
+ exit 1
+fi
+
+wait_for_iface() {
+ local _iface="$1"
+ local _timeout="${2:-50}"
+ while [ "$_timeout" -ne 0 ]; do
+ [ "$(cat /sys/class/net/${_iface}/operstate)" = "up" ] && break
+ (( _timeout -- ))
+ usleep 100000
+ done
+ [ "$_timeout" -ne 0 ]
+}
+
+# For debugging...
+{
+set -x
+
+ip link set dev "$SLX_PXE_NETIF" up
+if ! wait_for_iface "$SLX_PXE_NETIF" 100; then
+ warn "'$SLX_PXE_NETIF' still not up after 10sec ..."
+ # TODO handle case where we waited for 10sec and it is still not up
+fi
+
+if [ -n "$SLX_BRIDGE" ]; then
+ for try in 1 2 3 fail; do
+ (
+ set -e
+ brctl addbr "$SLX_BRIDGE"
+ brctl stp "$SLX_BRIDGE" 0
+ brctl setfd "$SLX_BRIDGE" 0.000000000001
+ ip link set addr "$SLX_PXE_MAC" "$SLX_BRIDGE"
+ brctl addif "$SLX_BRIDGE" "$SLX_PXE_NETIF"
+ ip link set dev "$SLX_BRIDGE" up
+ wait_for_iface "$SLX_BRIDGE"
+ )
+ # success?
+ [ "$?" -eq 0 ] && break
+
+ # nope, handle
+ if [ "$try" = "fail" ]; then
+ emergency_shell "Failed to setup main network bridge, giving up!"
+ fi
+ warn "Failed to setup main network bridge on try $try. Retrying ..."
+ # delete bridge, inc try and sleep 100ms before trying again
+ [ -e "/sys/class/net/${SLX_BRIDGE}" ] && brctl delbr "$SLX_BRIDGE"
+ try=$(( try + 1 ))
+ usleep 100000
+ done
+fi
+# add the IP address on the bridge/boot if
+ip addr add \
+ "${SLX_PXE_CLIENT_IP}/$(ipcalc -s -p "$SLX_PXE_CLIENT_IP" "$SLX_PXE_NETMASK" | sed "s/.*=//")" \
+ broadcast "$(ipcalc -s -b "$SLX_PXE_CLIENT_IP" "$SLX_PXE_NETMASK" | sed "s/.*=//")" \
+ dev "${SLX_BRIDGE:-${SLX_PXE_NETIF}}"
+
+if [ "$USE_DHCP_UUID" = "yes" ] && [ -s "/run/system-uuid" ]; then
+ UUID="$(cat /run/system-uuid)"
+fi
+
+# udhcpc
+for i in 1 1 1 fail; do
+ [ "$i" = "fail" ] && emergency_shell "DHCP failed 3 times... cannot continue."
+ udhcpc -t 4 -T 3 -f -n -q \
+ -i "${SLX_BRIDGE:-${SLX_PXE_NETIF}}" \
+ "${SLX_PXE_CLIENT_IP:+-r $SLX_PXE_CLIENT_IP}" \
+ "${UUID:+-x 0x3d:$UUID}" \
+ -O ntpsrv -O domain -O wpad -O search -O nisdomain \
+ -s "/usr/local/bin/udhcpc-trigger"
+ # success?
+ [ "$?" -eq 0 ] && break
+ # nope, keep trying...
+ warn "DHCP failed, retrying in 1sec..."
+ sleep $i
+done
+
+set +x
+} &>> "${_logfile}.$$"
diff --git a/builder/modules.d/slx-network/scripts/udhcpc-trigger b/builder/modules.d/slx-network/scripts/udhcpc-trigger
new file mode 100755
index 00000000..778b55f9
--- /dev/null
+++ b/builder/modules.d/slx-network/scripts/udhcpc-trigger
@@ -0,0 +1,115 @@
+#!/bin/ash
+
+exec &> "/run/openslx/udhcpc-trigger.log.$$"
+set -x
+
+NETWORK_CONF="/run/openslx/network.conf"
+. "$NETWORK_CONF"
+
+if [ "x$1" != "xbound" -a "x$1" != "xrenew" ] \
+ || [ "x$interface" != "x${SLX_BRIDGE:-${SLX_PXE_NETIF}}" ] \
+ || [ -z "$ip" ]; then
+ exit 0
+fi
+
+# If we already got an IP from KCL, see if it differs, and remove first if so
+# We just try to prevent everything from breaking if the DHCP server doesn't
+# objey the renew request by the client and hands out a new address
+if [ -n "$SLX_PXE_CLIENT_IP" ]; then
+ #...some address is already configured...
+ if [ "x${SLX_PXE_CLIENT_IP}" != "x${ip}" ]; then
+ #...it's a different one, reconfigure...
+ echo "..reconfiguring ${SLX_PXE_CLIENT_IP} to ${ip}.."
+ # remove default route and let it be added again below, as it might get lost when changing the primary address on the interface
+ ip route del default 2>/dev/null
+ ip addr del "$SLX_PXE_CLIENT_IP" dev "${interface}" 2>/dev/null
+ ip addr add "${ip}/$(ipcalc -s -p "${ip}" "${subnet}" | sed s/.*=//)" dev "${interface}"
+ fi
+else
+ #...no address configured yet, just add...
+ echo "..adding ${ip}.."
+ ip addr add "${ip}/$(ipcalc -s -p "${ip}" "${subnet}" | sed s/.*=//)" dev "${interface}"
+fi
+echo "SLX_DHCP_CLIENT_IP='$ip'" >> "$NETWORK_CONF"
+
+# Same procedure for default gateway
+if [ -n "${router}" ]; then
+ if [ -s "$SLX_PXE_GATEWAY" ]; then
+ if [ "x${SLX_PXE_GATEWAY}" != "x${router}" ]; then
+ echo "..reconfiguring default gw from ${SLX_PXE_GATEWAY} to ${router}.."
+ ip route del default 2>/dev/null
+ ip route add default via "$router"
+ fi
+ else
+ ip route add default via "$router"
+ fi
+ echo "SLX_DHCP_GATEWAY='$router'" >> "$NETWORK_CONF"
+fi
+
+rm -f -- "/etc/resolv.conf"
+
+# DNS/domain?
+if [ -n "$dns" ]; then
+ echo "..got DNS.."
+ echo "# From DHCP in stage 3.1" >> "$NETWORK_CONF"
+ echo "SLX_DNS='$dns'" >> "$NETWORK_CONF"
+fi
+for srv in $dns; do
+ echo "nameserver $srv" >> "/etc/resolv.conf"
+done
+if [ -z "$domain" ]; then
+ # try to get domain via reverse lookup if empty
+ echo "..trying to get domain via DNS, as DHCP didn't supply one.."
+ fqdn=$(timeout -t 3 nslookup "$ip" | grep -E "^Address +[0-9]+: +$ip " | head -n 1 | awk '{print $4}')
+ domain="${fqdn#*.}"
+fi
+# Add domain to list of search domains if not in there yet
+if [ -n "$domain" ] && [ -n "$search" ]; then
+ FOUND=no
+ for sd in $search; do
+ [ "x$sd" = "x$domain" ] && FOUND=yes
+ done
+ [ "$FOUND" = "no" ] && search="$domain $search"
+elif [ -n "$domain" ]; then
+ search="$domain"
+fi
+# Write out
+if [ -n "$domain" ]; then
+ echo "domain $domain" >> "/etc/resolv.conf"
+ echo "SLX_NET_DOMAIN='$domain'" >> "/run/openslx/network.conf"
+fi
+if [ -n "$search" ]; then
+ echo "search $search" >> "/etc/resolv.conf"
+ echo "SLX_NET_SEARCH='$search'" >> "/run/openslx/network.conf"
+fi
+
+if [ -n "$ntpsrv" ]; then
+ echo "SLX_DHCP_NTP='$ntpsrv'" >> "/run/openslx/network.conf"
+fi
+
+# Hostname
+if [ -z "$hostname" ]; then
+ # as with domain, if there's no hostname, try to get via DNS
+ echo "..trying to get hostname via DNS, as DHCP didn't supply one.."
+ [ -z "$fqdn" ] && fqdn=$(timeout -t 3 nslookup "$ip" | grep -E "^Address +[0-9]+: +$ip " | head -n 1 | awk '{print $4}')
+ hostname="${fqdn%%.*}"
+elif [ -n "$domain" ]; then
+ fqdn="${hostname}.${domain%% *}" # in case domain is a list
+fi
+
+if [ -z "$hostname" ]; then
+ # no fallback hostname from DNS, use IP address
+ hostname="${ip//./-}"
+fi
+
+if [ -n "$hostname" ]; then
+ [ -z "$fqdn" ] && fqdn="$hostname"
+ echo "..setting hostname $hostname (fqdn: $fqdn).."
+ echo "$hostname" > "/proc/sys/kernel/hostname"
+ echo "$hostname" > "/etc/hostname"
+ echo "127.0.0.1 localhost" > "/etc/hosts"
+ echo "127.0.1.1 $fqdn $hostname" >> "/etc/hosts"
+ echo "SLX_HOSTNAME='$hostname'" >> "/run/openslx/network.conf"
+fi
+
+touch /.network